from typing import Generic, TypeVar

from rainbowadn.chain.chaincollectioninterface import ChainCollectionInterface
from rainbowadn.hashing.nullability.nullablereference import NullableReference

__all__ = ('ChainCollectionFactory',)

BlockType = TypeVar('BlockType')
HeaderType = TypeVar('HeaderType')
ActualStateType = TypeVar('ActualStateType')


class ChainCollectionFactory(Generic[BlockType, HeaderType, ActualStateType]):
    def empty(self) -> ChainCollectionInterface[BlockType, HeaderType, ActualStateType]:
        raise NotImplementedError

    def from_reference(
            self,
            reference: NullableReference[BlockType]
    ) -> ChainCollectionInterface[BlockType, HeaderType, ActualStateType]:
        raise NotImplementedError

    def loose(self) -> 'ChainCollectionFactory[BlockType, HeaderType, ActualStateType]':
        return self
