import abc
from typing import Generic, TypeVar

from rainbowadn.chain.blockcollectioninterface import BlockCollectionInterface
from rainbowadn.hashing.hashpoint import HashPoint

__all__ = ('ChainCollectionInterface',)

BlockType = TypeVar('BlockType')
HeaderType = TypeVar('HeaderType')
ActualStateType = TypeVar('ActualStateType')


class ChainCollectionInterface(
    BlockCollectionInterface[
        BlockType,
        HeaderType,
        ActualStateType
    ],
    Generic[BlockType, HeaderType, ActualStateType],
    abc.ABC
):
    def add(self, header: HashPoint[HeaderType]) -> 'ChainCollectionInterface[BlockType, HeaderType, ActualStateType]':
        raise NotImplementedError

    def verify(self) -> bool:
        raise NotImplementedError
