from typing import Generic, TypeVar

from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.nullability.nullablereference import NullableReference

__all__ = ('StateProtocol',)

HeaderType = TypeVar('HeaderType')
StateType = TypeVar('StateType')


class StateProtocol(Generic[HeaderType, StateType]):
    def verify(
            self,
            previous: NullableReference[StateType],
            header: HashPoint[HeaderType],
            state: HashPoint[StateType]
    ) -> bool:
        raise NotImplementedError
