from rainbowadn.data.atomic.atomic import Atomic

__all__ = ('Integer',)


class Integer(Atomic):
    def __init__(self, integer: int):
        assert isinstance(integer, int)
        assert integer >= 0
        self.integer = integer

    @classmethod
    def _from_bytes(cls, source: bytes) -> 'Integer':
        assert isinstance(source, bytes)
        return cls(int.from_bytes(source, 'little'))

    def __bytes__(self):
        return self.integer.to_bytes((self.integer.bit_length() + 7) // 8, 'little')

    def __str__(self):
        return str(self.integer)
