from typing import Generic, TypeVar

from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.nullability.nullable import Nullable

__all__ = ('QueryCollectionInterface',)

KeyType = TypeVar('KeyType')


class QueryCollectionInterface(Generic[KeyType]):
    def query(self, key: HashPoint[KeyType]) -> Nullable[HashPoint[KeyType]]:
        raise NotImplementedError
