from typing import Generic, TypeVar

from rainbowadn.data.collection.collection_interface.activecollectioninterface import ActiveCollectionInterface
from rainbowadn.data.collection.keyvalue import KeyValue
from rainbowadn.hashing.hashpoint import HashPoint

__all__ = ('ActiveMapping',)

KVKeyType = TypeVar('KVKeyType')
KVValueType = TypeVar('KVValueType')


class ActiveMapping(Generic[KVKeyType, KVValueType]):
    def __init__(
            self,
            collection: ActiveCollectionInterface[KeyValue[KVKeyType, KVValueType]]
    ):
        assert isinstance(collection, ActiveCollectionInterface)
        self.collection = collection

    def add(self, key: HashPoint[KVKeyType], value: HashPoint[KVValueType]) -> 'ActiveMapping[KVKeyType, KVValueType]':
        assert isinstance(key, HashPoint)
        assert isinstance(value, HashPoint)
        return ActiveMapping(
            self.collection.add(HashPoint.of(KeyValue(key, value)))
        )
