from typing import Generic, TypeVar

from rainbowadn.hashing.hashpoint import HashPoint

__all__ = ('BinaryTreeCreationProtocol',)

TreeType = TypeVar('TreeType')
ActiveKeyType = TypeVar('ActiveKeyType')
MetaDataType = TypeVar('MetaDataType')


class BinaryTreeCreationProtocol(Generic[ActiveKeyType, MetaDataType, TreeType]):
    def splittable(self, tree: TreeType) -> bool:
        raise NotImplementedError

    def split(self, tree: TreeType) -> tuple[TreeType, HashPoint[ActiveKeyType], HashPoint[MetaDataType], TreeType]:
        raise NotImplementedError

    def tree(self, treel: TreeType, treer: TreeType, key: HashPoint[ActiveKeyType]) -> TreeType:
        raise NotImplementedError
