from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.recursivementionable import RecursiveMentionable

__all__ = ('hash_point_format', 'tabulate',)


def hash_point_format(hash_point: HashPoint, tab: int) -> str:
    assert isinstance(hash_point, HashPoint)
    assert isinstance(tab, int)
    value = hash_point.resolve()
    if isinstance(value, RecursiveMentionable):
        return value.str(tab)
    else:
        return str(value)


newline = False


def tabulate(tab: int) -> str:
    assert isinstance(tab, int)
    if newline:
        return '\n' + '    ' * tab
    else:
        return ' '
