from typing import TypeVar

from rainbowadn.hashing.rainbow_factory import RainbowFactory

__all__ = ('HashMentionable',)

HashMentioned = TypeVar('HashMentioned')


class HashMentionable:
    def __bytes__(self):
        raise NotImplementedError

    def __factory__(self: HashMentioned) -> RainbowFactory[HashMentioned]:
        raise NotImplementedError

    def __topology_hash__(self) -> bytes:
        raise NotImplementedError
