from typing import Generic, TypeVar

from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.metaorigin import MetaOrigin
from rainbowadn.hashing.origin import Origin
from rainbowadn.hashing.rainbow_factory import RainbowFactory

__all__ = ('LocalMetaOrigin',)

OriginType = TypeVar('OriginType')


class LocalMetaOrigin(MetaOrigin[OriginType], Generic[OriginType]):
    def __init__(self, origin: Origin[OriginType]):
        assert isinstance(origin, Origin)
        self._origin = origin

    def origin(self, factory: RainbowFactory[OriginType], point: bytes) -> Origin[OriginType]:
        assert isinstance(factory, RainbowFactory)
        assert isinstance(point, bytes)
        assert len(point) == HashPoint.HASH_LENGTH
        return self._origin
