from typing import Generic, TypeVar

from rainbowadn.hashing.hashmentionable import HashMentionable
from rainbowadn.hashing.origin import Origin

__all__ = ('LocalOrigin',)

OriginType = TypeVar('OriginType')


class LocalOrigin(Origin[OriginType], Generic[OriginType]):
    def __init__(self, value: OriginType):
        assert isinstance(value, HashMentionable)
        self.value: OriginType = value

    def resolve(self) -> OriginType:
        return self.value
