from typing import Generic, TypeVar

from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.origin import Origin
from rainbowadn.hashing.rainbow_factory import RainbowFactory

__all__ = ('MetaOrigin',)

OriginType = TypeVar('OriginType')


class MetaOrigin(Generic[OriginType]):
    def origin(self, factory: RainbowFactory[OriginType], point: bytes) -> Origin[OriginType]:
        raise NotImplementedError

    def hash_point(self, factory: RainbowFactory[OriginType], point: bytes) -> HashPoint[OriginType]:
        assert isinstance(factory, RainbowFactory)
        assert isinstance(point, bytes)
        assert len(point) == HashPoint.HASH_LENGTH
        return HashPoint(factory, point, self.origin(factory, point))
