import abc
from typing import Iterable

from rainbowadn.hashing.hashmentionable import HashMentionable
from rainbowadn.hashing.hashpoint import HashPoint

__all__ = ('RecursiveMentionable',)


class RecursiveMentionable(HashMentionable, abc.ABC):
    def points(self) -> Iterable[HashPoint]:
        raise NotImplementedError

    def str(self, tab: int) -> str:
        assert isinstance(tab, int)
        return f'(recursive {self.__class__.__name__})'

    def __topology_hash__(self) -> bytes:
        return HashPoint.hash(b''.join(hash_point.point for hash_point in self.points()))
