from typing import TypeVar

from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.hashresolver import HashResolver
from rainbowadn.hashing.nullability.notnull import NotNull
from rainbowadn.hashing.nullability.null import Null
from rainbowadn.hashing.nullability.nullablereference import NullableReference

__all__ = ('reduce_nullable_reference',)

ReReferencedType = TypeVar('ReReferencedType')


def reduce_nullable_reference(
        reference: NullableReference[NullableReference[ReReferencedType]],
        resolver: HashResolver
) -> NullableReference[ReReferencedType]:
    assert isinstance(reference, NullableReference)
    assert isinstance(resolver, HashResolver)
    if isinstance(reference.reference, Null):
        return reference.factory.from_bytes(HashPoint.NULL_HASH, resolver)
    elif isinstance(reference.reference, NotNull):
        return reference.reference.value.resolve()
    else:
        raise TypeError
